; Add this file to the end of your .emacs file or load this file from your .emacs file.
; On a PC, place the .emacs file in c:/.
; On unix, put the .emacs file in the root of your home directory.

; loads the LAML emacs support
(load "/user/normark/scheme/laml.el") 

; loads the Scheme Elucidator Emacs support
(load "/user/normark/scheme/styles/elucidator/elucidator.el")  

(defun laml-customize ()
  (interactive)
  (customize-group 'laml))

; -----------------------------------------------------------------------------
; Laml mode key bindings.

; Arrange that C-o starts asynchronous laml processing
(define-key laml-mode-map "\C-o" 'laml-process-current-buffer)

; Arrange that C-x C-o starts synchronous laml processing
(define-key laml-mode-map "\C-x\C-o" 'laml-sync-process-current-buffer)

; Arrange that C-x C-e calls the LAML embed command:
(define-key laml-mode-map "\C-x\C-e" 'embed)

; Arrange that C-x C-r calls the LAML unembed command:
(define-key laml-mode-map "\C-x\C-r" 'unembed)

; Arrange that C-M-q indents the currently selected S-expression
(define-key laml-mode-map "\C-\M-q" 'indent-sexp)

; Arrange taht TAB (C-i) runs indent-for-tab-command, as in Scheme mode.
(define-key laml-mode-map "\C-i" 'indent-for-tab-command)

; Leno Laml mode key bindings
(define-key laml-mode-map "\C-l\C-a" 'insert-notesection)
(define-key laml-mode-map "\C-l\C-b" 'insert-notepage)
(define-key laml-mode-map "\C-l\C-p" 'insert-point)
(define-key laml-mode-map "\C-l\C-i" 'insert-items)
(define-key laml-mode-map "\C-l\C-s" 'insert-slide-space)



; -----------------------------------------------------------------------------
; Laml mode menu bindings.

(define-key laml-mode-map [menu-bar laml]
    (cons "Laml" (make-sparse-keymap "Laml")))

; -----------------------------------------------------------------------------

; LENO:

(define-key laml-mode-map [menu-bar laml leno]
    (cons "Leno" (make-sparse-keymap "Leno")))

(define-key laml-mode-map [menu-bar laml leno make-lecture-notes]
      '("Make new lecture notes" . make-lecture-notes))


(define-key laml-mode-map [menu-bar laml leno insert-text]
    '("Insert text" . insert-text))


(define-key laml-mode-map [menu-bar laml leno insert-source-program]
    '("Insert source-program" . insert-source-program))

(define-key laml-mode-map [menu-bar laml leno insert-image]
    '("Insert image" . insert-image))

(define-key laml-mode-map [menu-bar laml leno insert-example]
    '("Insert example" . insert-example))

(define-key laml-mode-map [menu-bar laml leno insert-syntax]
    '("Insert syntax" . insert-syntax))

(define-key laml-mode-map [menu-bar laml leno insert-slide-space]
    '("Insert slide space" . insert-slide-space))

(define-key laml-mode-map [menu-bar laml leno insert-tabular]
    '("Insert tabular" . insert-tabular))

(define-key laml-mode-map [menu-bar laml leno insert-note-text]
    '("Insert note text" . insert-note-text))

(define-key laml-mode-map [menu-bar laml leno insert-slide-text]
    '("Insert slide text" . insert-slide-text))

(define-key laml-mode-map [menu-bar laml leno insert-cross-references]
    '("Insert cross references" . insert-cross-references))

(define-key laml-mode-map [menu-bar laml leno insert-internet-reference]
    '("Insert internet reference" . insert-internet-reference))

(define-key laml-mode-map [menu-bar laml leno insert-note-reference]
    '("Insert note reference" . insert-note-reference))

(define-key laml-mode-map [menu-bar laml leno insert-informal-reference]
    '("Insert informal reference" . insert-informal-reference))

(define-key laml-mode-map [menu-bar laml leno insert-exercise]
    '("Insert exercise" . insert-exercise))

(define-key laml-mode-map [menu-bar laml leno insert-long-slide]
    '("Insert long slide" . insert-long-slide))

(define-key laml-mode-map [menu-bar laml leno insert-index-words]
    '("Insert index words" . insert-index-words))

(define-key laml-mode-map [menu-bar laml leno insert-image-series]
    '("Insert image series" . insert-image-series))

(define-key laml-mode-map [menu-bar laml leno insert-section-title]
    '("Insert section title" . insert-section-title))

(define-key laml-mode-map [menu-bar laml leno insert-slide-image]
    '("Insert slide image" . insert-slide-image))

(define-key laml-mode-map [menu-bar laml leno insert-applet-program]
    '("Insert applet program" . insert-applet-program))

(define-key laml-mode-map [menu-bar laml leno insert-quotation]
    '("Insert quotation" . insert-quotation))

(define-key laml-mode-map [menu-bar laml leno insert-opposing]
      '("Insert opposing items" . insert-opposing))

(define-key laml-mode-map [menu-bar laml leno insert-concept-list]
      '("Insert concept list" . insert-concept-list))

(define-key laml-mode-map [menu-bar laml leno insert-synopsis]
      '("Insert synopsis" . insert-synopsis))

(define-key laml-mode-map [menu-bar laml leno insert-title]
    '("Insert title" . insert-title))

(define-key laml-mode-map [menu-bar laml leno insert-point]
    '("Insert point" . insert-point))

(define-key laml-mode-map [menu-bar laml leno insert-items]
      '("Insert items" . insert-items))

(define-key laml-mode-map [menu-bar laml leno insert-notepage]
      '("Insert note page" . insert-notepage))

(define-key laml-mode-map [menu-bar laml leno insert-notesection]
      '("Insert note section page" . insert-notesection))

; End LENO bindings


; Elucidator bindings

(define-key laml-mode-map [menu-bar laml elucidator]
     (cons "Elucidator" (make-sparse-keymap "Elucidator")))

 
; (define-key laml-mode-map [menu-bar laml elucidator insert-sectional-comment]
;     '("insert sectional comment" . insert-sectional-comment))
; 
; (define-key laml-mode-map [menu-bar laml elucidator elucidator-show-processing]
;     '("elucidator show processing" . elucidator-show-processing))
; 
; (define-key laml-mode-map [menu-bar laml elucidator elucidator-let-be]
;     '("elucidator let be" . elucidator-let-be))
; 
; (define-key laml-mode-map [menu-bar laml elucidator insert-documentation-entry]
;     '("insert documentation entry" . insert-documentation-entry))
; 
; (define-key laml-mode-map [menu-bar laml elucidator insert-documentation-section]
;     '("insert documentation section" . insert-documentation-section))
; 
; (define-key laml-mode-map [menu-bar laml elucidator large-program-window]
;     '("large program window" . large-program-window))
; 
; (define-key laml-mode-map [menu-bar laml elucidator large-documentation-window]
;     '("large documentation window" . large-documentation-window))
;
; (define-key laml-mode-map [menu-bar laml elucidator back]
;     '("go back" . back))
; 
; (define-key laml-mode-map [menu-bar laml elucidator goto]
;     '("goto" . goto))
; 
; (define-key laml-mode-map [menu-bar laml elucidator doc-ref]
;     '("insert doc ref" . doc-ref))
;
;(define-key laml-mode-map [menu-bar laml elucidator elucidate]
;    '("elucidate" . elucidate))
; 
; (define-key laml-mode-map [menu-bar laml elucidator surround-none-ref]
;     '("surround prog ref - none" . surround-none-ref))
; 
; (define-key laml-mode-map [menu-bar laml elucidator surround-prog-ref]
;     '("surround prog ref" . surround-prog-ref))
; 
; (define-key laml-mode-map [menu-bar laml elucidator prog-ref]
;     '("insert prog ref" . prog-ref))



(define-key laml-mode-map [menu-bar laml elucidator elucidator-help]
    '("elucidator help" . elucidator-help))

(define-key laml-mode-map [menu-bar laml elucidator elucidator-status]
    '("elucidator status" . elucidator-status))

(define-key laml-mode-map [menu-bar laml elucidator show-setup]
    '("show setup" . show-setup))

(define-key laml-mode-map [menu-bar laml elucidator refresh-elucidator]
    '("refresh elucidator" . refresh-elucidator))

(define-key laml-mode-map [menu-bar laml elucidator show-program]
    '("show program" . show-program))

(define-key laml-mode-map [menu-bar laml elucidator reset-elucidator]
    '("reset elucidator" . reset-elucidator))

(define-key laml-mode-map [menu-bar laml elucidator setup-elucidator]
    '("setup elucidator" . setup-elucidator))

(define-key laml-mode-map [menu-bar laml elucidator make-elucidator]
    '("make elucidator" . make-elucidator))


; End Elucidator bindings



; Main LAML menu entries

(define-key laml-mode-map [menu-bar laml laml-customize]
      '("Customize LAML" . laml-customize))

(define-key laml-mode-map [menu-bar laml insert-laml-template]
      '("Insert LAML template" . insert-laml-template))

(define-key laml-mode-map [menu-bar laml indent-sexp]
      '("Indent symbolic expression" . indent-sexp))

(define-key laml-mode-map [menu-bar laml unembed]
      '("Unembed form" . unembed))

(define-key laml-mode-map [menu-bar laml embed]
      '("Embed in form" . embed))

(define-key laml-mode-map [menu-bar laml process-sync]
      '("Process syncronously" . laml-sync-process-current-buffer))

(define-key laml-mode-map [menu-bar laml process-async]
      '("Process asyncronously" . laml-process-current-buffer))

; End main LAML menu entries







